@echo off
TITLE HUDFramework Auto-Patcher

REM Check for Java
where java > bin\temp.txt 2>&1
find "INFO:" bin\temp.txt > bin\temp2.txt 2>&1

IF %errorlevel% EQU 0 GOTO NO_JAVA
goto JAVA_OK

:NO_JAVA
echo Autopatch requires Java, which is not installed on this machine.
echo.
goto END

:NO_HUDMENU
echo.
echo No HUDMenu.swf found.
echo.
goto END

:ALREADY_PATCHED
echo.
echo HUDMenu.swf is already patched.
goto END

:CANCEL
echo.
echo Cancelled.
goto END

:JAVA_OK
echo ---- HUDFramework Auto-Patcher Information ----
echo.
echo The auto-patcher automatically injects HUDFramework into any HUDMenu.swf.
echo Ensure that the HUDMenu.swf to be patched is in the current directory.
echo The patched file will be named HUDMenu_patched.swf.
echo The original file will not be changed.
echo.
echo To use the patched file, rename HUDMenu_patched.swf to HUDMenu.swf and
echo place in the Data\Interface folder.
echo.
set c=Y
set /P c=Continue? [Enter/Y/N]: 
if /I "%c%" NEQ "Y" (
    goto CANCEL
)

if not exist "HUDMenu.swf" (
    goto NO_HUDMENU
)

REM Remove existing folder (if present).
rd /S /Q "HUDMenu_patched-0" > NUL 2>&1

REM Make a copy
echo Creating copy...
copy /b /y "HUDMenu.swf" "HUDMenu_patched.swf"

echo.
echo Disassembling HUDMenu.swf...

"bin/abcexport" HUDMenu_patched.swf
"bin/rabcdasm" HUDMenu_patched-0.abc

if exist "HUDMenu_patched-0\Messages.instance\Update\inline_method.method.asasm" (
    goto ALREADY_PATCHED
)

echo.
echo Patching...
java -jar AutoPatcher.jar

echo.
echo Copying patch files...
xcopy /s /y /q /exclude:hudframework\copy_exclusion.txt hudframework\HUDMenu-0 HUDMenu_patched-0

echo.
echo Reassembling HUDMenu_patched.swf...

"bin/rabcasm" HUDMenu_patched-0/HUDMenu_patched-0.main.asasm
"bin/abcreplace" HUDMenu_patched.swf 0 HUDMenu_patched-0/HUDMenu_patched-0.main.abc

echo.
echo Patch complete.
echo.

:END
del bin\temp.txt
del bin\temp2.txt
del HUDMenu_patched-0.abc > NUL 2>&1
rd /S /Q "HUDMenu_patched-0"
pause
goto :EOF